#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Feb 26 14:50:30 2021

@author: auctus
"""

import rospy
import sys

import pyosim.OsimModel

import osim2urdf_parser

import opensim as osim
import os

import json

from std_srvs.srv import SetBool
from optitrack_full.srv import calibration, scaling


def kill_process(grepline,line_to_find):
    str_process = os.popen('ps -aux | grep "'+ grepline + '" ').read().split("\n")
    k = 0
    find = False
    pid = -1
    line = line_to_find
    while k < len(str_process) and (not find) :
        if line in str_process[k]:
            words = str_process[k].split(" ") 
            i = 0
            while i < len(words):
                try:
                    pid = int(words[i])
                    i = len(words)
                except ValueError:
                    i+=1
            find = True
        else:
            k+=1
    if (pid != -1):
        os.kill(pid,9)

class scalingManager:
    """!
    Class managing all the operations about the scaling of a Opensim (and the URDF model derived from it),
    from the call to the Opensim ScaleTool to the creation of the new URDF model.
    """    
    def __init__(self,rate):
        """!
        
        Constructor of the scalingManager class. 

        @param rate : float.
            Rate associated with the node.

        @return None.

        """
        # ---- Given by a service

        ### Absolute path to the non-scaled Opensim model.
        self.complete_osim_path = ""
        ### Path to the .trc file used for scaling.        
        self.TRCPath = ""
        ### Path to the .mot file used for scaling.
        self.MOTPath = ""
        ### Path to the .xml file used for scaling.
        self.scaleFile = ""        
        ### Path to the .json file containing all necessary informations for the
        ### .urdf writing (vtp_path, ros_package_path, exactly_collision, exactly_visual,
        ### correct_stl_dic)..
        self.dataFile = ""
        ### Path to the temporary folder (created only for scaling purpose, and deleted at
        ### the end of the operation).
        self.tempFolder = ""
        ### Mass of the model. May be useful for scalingTool.
        self.mass = -1

        # ---- Given by .json file

        ### Path to the .stl files. As we supposed the non-scaled Opensim model
        ### was already generated, there is no nedd to create again .stl files from
        ### .vtp files. This is why the path to .stl files is directly given to the
        ### osim2urdf_parser.
        self.stl_path = ""
        ### Path to the ROS Package containing the URDF model.
        self.ros_package_path = ""
        ### True : try to represent the collision aspect of the model from the .stl files.
        ### False : use approximations according to the dimensions of the .stl file.
        self.exactly_collision = ""
        ### True : try to represent the visual aspect of the model from the .stl files.
        ### False : use approximations according to the dimensions of the .stl file.        
        self.exactly_visual = ""
        ### Used to correct the positions of the .stl files.
        self.correc_stl_dic = {}

        # ---- Generated by the node

        ### Absolute path to the scaled Opensim model.
        self.osim_scaled_path = ""
        ### Name of the scaled .osim model (without extension).
        self.model_name_scaled = ""
        ### Opensim Model object.
        self.osimModel = None
        ### SimTK State object.
        self.osimState = None
        ### Name of the package containing the URDF file.
        self.package_name = ""
        ### Name of the .osim model (without extension).
        self.model_name = ""

        self.D_body_scaling = {}

        # ---- Triggers

        ### Indicates if scaling was asked (by mocap_node) and processed.
        self.scaling_asked = False
        ### Indicates if the decision about scaling (keep it or cancel it)
        ### was received and processed.
        self.confirmation_received = False

        rospy.init_node('scaling_manager')
        ### Rate of the node.
        self.rate = rospy.Rate(rate)
        ### Service used to process the scaling operation
        s1 = rospy.Service('/mocap_node/execute_scaling', scaling, self.execute_scaling)
        ### Service used to process the acceptance or rejection of the scaling operation.
        s2 = rospy.Service('/mocap_node/confirm_scaling',SetBool, self.confirm_scaling)

        print("Ready for python scaling.\n")
        ## While the acceptance or rejection of scaling is not processed, the node remains activated.
        while not rospy.is_shutdown() and not self.confirmation_received:
            pass

    def confirm_scaling(self,msg):
        """!
        Service used to process the acceptance or rejection of the scaling operation.

        @param msg : SetBool Service. 
            Acceptance (data=true) or rejection (data=false) of the scaling.
        
        @return : Response of the SetBool service.

        """
        if (self.scaling_asked):
            confirmation = msg.data
            if confirmation == False:
                ## In this case, all nodes created by the scaling operation are stopped
                ## (joint_state_publihser and its GUI interface, robot_state_publisher, spawn_urdf, )
                os.system("rosnode kill /joint_state_publisher /robot_state_publisher /spawn_urdf")
                os.system("rosnode kill /"+ self.model_name_scaled + "/controller_spawner")
                line = "/joint_states:=/" + self.model_name_scaled + "/joint_states"
                kill_process("/joint_states:=",line)
                ## Then, the original nodes used by mocap_node are launched again.
                os.system("roslaunch "+ self.package_name + " human_control.launch activate_rviz:=false &")
            ## Delete temporary folder
            os.system("rm -rf " + self.tempFolder)            
            ## Activates the trigger.
            self.confirmation_received = True
        return(True,"ok")
            
        

    
    def scaling_process(self):
        """!

        Method used to process all the necessary steps of the scaling operation (of the .osim and
        then of the .urdf model).
        First, the .osim model is scaled thanks to the Opensim ScaleTool; then, a new URDF file is created
        from this .osim model.

        """
        ## -- Scaling step

        ## Kill original nodes used for .urdf file.
        ## (joint_state_publihser and its GUI interface, robot_state_publisher, spawn_urdf, )
        os.system("rosnode kill /joint_state_publisher /robot_state_publisher /spawn_urdf")
        os.system("rosnode kill /"+ self.model_name + "/controller_spawner")

        line = "/joint_states:=/" + self.model_name + "/joint_states"
        kill_process("/joint_states:=",line)

        ## Just in case, also kill nodes which could be linked to model scaled 
        ## (joint_state_publihser and its GUI interface, robot_state_publisher, spawn_urdf, )
        os.system("rosnode kill /joint_state_publisher /robot_state_publisher /spawn_urdf")
        os.system("rosnode kill /"+ self.model_name_scaled + "/controller_spawner")
        line = "/joint_states:=/" + self.model_name_scaled + "/joint_states"
        kill_process("/joint_states:=",line)        

        ## Create Model and State of non-scaled Opensim model
        self.osimModel = osim.Model(self.complete_osim_path)
        self.osimState = self.osimModel.initSystem()
        
        ## Do scaling operation
        OsimModel.scaling(self.osimModel,self.osimState,self.tempFolder,self.complete_osim_path,self.scaleFile, self.TRCPath, self.MOTPath, self.mass, self.D_body_scaling)

        ## -- Start osim2urdf_parser with new osim file

        ## Load parameters from .json file, for Osim2URDF
        self.loadParserParameters()

        ## Get path to .osim scaled file.
        LosimPath =self.complete_osim_path.split("/")
        
        osimPath = LosimPath[0]
        for i in range(1,len(LosimPath)-1):
            osimPath+= "/"+ LosimPath[i]
        
        osimPath+="/"

        self.osim_scaled_path = osimPath

        filename = self.model_name_scaled + '.osim'

        ## Do .osim to .urdf operation.
        osim2urdf_parser.Osim2URDF(self.osim_scaled_path, "", filename, self.ros_package_path, self.exactly_visual, self.exactly_collision,self.correc_stl_dic, add_rviz = False, roslaunch_name = "urdf_scaled", stl_path = self.stl_path ,trans_plugin=True,verbose = False,xacro=True,free_flyer=False)

        ## Relaunch spawn_urdf, robot_state_publisher, ... with scaled urdf file
        os.system("roslaunch "+ self.package_name + " urdf_scaled.launch &")

    def execute_scaling(self,msg):
        """!

        Service used to activate the scaling process.

        @param msg : scaling Service
            Service containing all necessary informations for the scaling process.

        """

        print("Scaling asked in Python! \n")

        ## Get all informations from the scaling service.
        self.complete_osim_path = msg.osim_path
        self.TRCPath = msg.TRCPath
        self.MOTPath = msg.MOTPath
        self.mass = msg.mass
        self.scaleFile = msg.scaleFile
        self.dataFile = msg.dataFile
        self.ros_package_path = msg.rosPackagePath

        body_names = msg.bodyNames
        scaling_factors = msg.scalingFactors

        for i in range ( len(body_names) ):
            self.D_body_scaling[body_names[i]] = [scaling_factors[3*i], scaling_factors[3*i+1], scaling_factors[3*i+2]   ]

        ## Process other informations obtained from those first informations
        self.package_name = self.ros_package_path.split("/")[-1]

        model_name = self.complete_osim_path.split("/")[-1].split(".")[0]

        self.model_name = model_name
        self.model_name_scaled = model_name + "ScaledPlaced"

        TRCsplit = self.TRCPath.split("/")
        self.tempFolder = TRCsplit[0]
        for i in range(1,len(TRCsplit)-1):
            self.tempFolder+="/" + TRCsplit[i]
        self.tempFolder += "/"

        ## Activate scaling process
        self.scaling_process()

        ## Indicates that scaling process has been completed.
        self.scaling_asked = True

        return(True)

    def loadParserParameters(self):
        """!

        Method used to load all the necessary informations for the .osim to URDF operation,
        from a given .json file.

        """

        with open(self.dataFile) as json_file:
            data = json.load(json_file)

            for p in data[self.model_name+".osim"]:
                self.exactly_visual = p["exactly_visual"]
                self.exactly_collision = p["exactly_collision"]
                self.correc_stl_dic = p["correc_stl_dic"]
        
            self.stl_path = self.ros_package_path + "/description/" + self.model_name + "/stl"


        ## Correct a bug about the loading of the correct_stl_dic object,
        ## where all booleans keys are remplaced by string.
        ## This operation turns those keys back to booleans.
        for element in self.correc_stl_dic:

            new_element = {}

            if 'true' in self.correc_stl_dic[element]:
                pos = self.correc_stl_dic[element]['true']
                new_element[True] = pos
            else:
                new_element[True] = self.correc_stl_dic[element][True]
            
            if 'false' in self.correc_stl_dic[element]:
                pos = self.correc_stl_dic[element]['false']
                new_element[False] = pos
            else:
                new_element[False] = self.correc_stl_dic[element][False]            
            self.correc_stl_dic[element] = new_element

        return(None)


if __name__ == '__main__':

    ## scalingMananger object.
    sc = scalingManager(1)